apiVersion: build.openshift.io/v1
kind: BuildConfig
metadata:
  annotations:
    description: Scans Container images
  name: scan-image-clair-jenkins-pipeline
  namespace: {{ namespace }}
spec:
  strategy:
    jenkinsPipelineStrategy:
      jenkinsfile: |-
        def podLabel = "klar-${UUID.randomUUID().toString()}"
        pipeline {
            agent {
                kubernetes {
                    cloud 'openshift'
                    label podLabel
                    containerTemplate {
                        name 'jnlp'
                        image "{{ (opsimages | json_query("[?name=='jkagklar'].image"))[0] }}"
                    }
                    inheritFrom 'base'
                    serviceAccount '{{ jenkins_name }}'
                }
            }
            options { timeout(time: 65, unit: 'MINUTES') }
            parameters {
{% if clair_api_address | default(False) %}
                string(defaultValue: '{{ clair_api_address | urlsplit('hostname') }}', description: 'Clair Endpoint - Hostname', name: 'clairHost')
                string(defaultValue: '{{ clair_api_address | urlsplit('port') }}', description: 'Clair Endpoint - Port', name: 'clairPort')
                string(defaultValue: '{{ clair_api_address | urlsplit('scheme') }}', description: 'Clair Endpoint - Protocol', name: 'clairProto')
{% else %}
                string(defaultValue: '', description: 'Clair Endpoint - Hostname', name: 'clairHost')
                string(defaultValue: '6060', description: 'Clair Endpoint - Port', name: 'clairPort')
                string(defaultValue: 'http', description: 'Clair Endpoint - Protocol', name: 'clairProto')
{% endif %}
                string(defaultValue: '{{ (opsimages | json_query("[?name=='jkagklar'].image"))[0] }}', description: 'Docker Image Address to Scan', name: 'dockerImage')
            }
            stages {
                stage('scan image') {
                    steps {
                        script {
                            openshift.withCluster() {
                                openshift.withProject() {
                                    try {
                                        currentBuild.description = "[SCANNING] ${params.dockerImage}"
                                        timeout(60) {
                                            sh """
                                            echo "==== Scanning ${params.dockerImage} ===="
                                            if ! CLAIR_ADDR="${params.clairProto}://${params.clairHost}:${params.clairPort}" \\
                                                    CLAIR_TIMEOUT=10 DOCKER_INSECURE=true DOCKER_TIMEOUT=3 \\
{% if k8s_flavor == 'openshift' %}
                                                    DOCKER_USER={{ jenkins_name }} \\
                                                    DOCKER_PASSWORD="\$(cat /var/run/secrets/kubernetes.io/serviceaccount/token)" \\
                                                    JSON_OUTPUT=true REGISTRY_INSECURE=false DOCKER_INSECURE=false \\
{% elif docker_registry_token | default(False) %}
                                                    DOCKER_TOKEN={{ docker_registry_token }} \\
                                                    JSON_OUTPUT=true REGISTRY_INSECURE=false DOCKER_INSECURE=true \\
{% elif docker_registry_is_http | default(False) %}
                                                    JSON_OUTPUT=true REGISTRY_INSECURE=false DOCKER_INSECURE=true \\
{% else %}
                                                    JSON_OUTPUT=true REGISTRY_INSECURE=true DOCKER_INSECURE=true \\
{% endif %}
                                                    klar "${params.dockerImage}" >scan-output; then
                                                echo "==== Returned \$? ===="
                                            fi
                                            if ! test -s scan-output; then
                                                echo "==== Failed scanning image ===="
                                                rm scan-output
                                                exit 1
                                            fi
                                            echo "==== Done scanning - parsing output ===="
                                            for level in Critical Defcon1 High Low Medium Negligible Unknown
                                            do
                                                echo "==== Listing criticity '\$level' ===="
                                                cat scan-output | jq ".Vulnerabilities.\$level"
                                            done
                                            """
                                            def CRITICAL_COUNT = sh (
                                                    script: "cat scan-output | jq '.Vulnerabilities.Critical' | sed 's|^null\$|[]|' | jq '.[].Name ' | awk 'END{print NR}'",
                                                    returnStdout: true
                                                ).trim()
                                            def DEFCON1_COUNT = sh (
                                                    script: "cat scan-output | jq '.Vulnerabilities.Defcon1' | sed 's|^null\$|[]|' | jq '.[].Name ' | awk 'END{print NR}'",
                                                    returnStdout: true
                                                ).trim()
                                            def HIGH_COUNT = sh (
                                                    script: "cat scan-output | jq '.Vulnerabilities.High' | sed 's|^null\$|[]|' | jq '.[].Name ' | awk 'END{print NR}'",
                                                    returnStdout: true
                                                ).trim()
                                            def LOW_COUNT = sh (
                                                    script: "cat scan-output | jq '.Vulnerabilities.Low' | sed 's|^null\$|[]|' | jq '.[].Name ' | awk 'END{print NR}'",
                                                    returnStdout: true
                                                ).trim()
                                            def MEDIUM_COUNT = sh (
                                                    script: "cat scan-output | jq '.Vulnerabilities.Medium' | sed 's|^null\$|[]|' | jq '.[].Name ' | awk 'END{print NR}'",
                                                    returnStdout: true
                                                ).trim()
                                            def NEGLIGIBLE_COUNT = sh (
                                                    script: "cat scan-output | jq '.Vulnerabilities.Negligible' | sed 's|^null\$|[]|' | jq '.[].Name ' | awk 'END{print NR}'",
                                                    returnStdout: true
                                                ).trim()
                                            def UNKNOWN_COUNT = sh (
                                                    script: "cat scan-output | jq '.Vulnerabilities.Unknown' | sed 's|^null\$|[]|' | jq '.[].Name ' | awk 'END{print NR}'",
                                                    returnStdout: true
                                                ).trim()
                                            sh "rm -f scan-output"
                                            def score = "UNKNOWN"
                                            if (CRITICAL_COUNT != "0" || DEFCON1_COUNT != "0") { score = "CRITICAL" }
                                            else {
                                                if (HIGH_COUNT != "0") { score = "WARNING" }
                                                else { score = "OK" }
                                            }
                                            def notifyMsg = """
                                            [${score}] ${params.dockerImage}
                                            critical: ${CRITICAL_COUNT}
                                            defcon1: ${DEFCON1_COUNT}
                                            high: ${HIGH_COUNT}
                                            low: ${LOW_COUNT}
                                            medium: ${MEDIUM_COUNT}
                                            negligible: ${NEGLIGIBLE_COUNT}
                                            unknown: ${UNKNOWN_COUNT}
                                            """.stripIndent()
                                            currentBuild.description = notifyMsg
                                            echo "${notifyMsg}"
                                            def notifyPost = notifyMsg.replaceAll('"', "'")
                                            echo "${notifyMsg}"
                                            try {
                                                withCredentials([string(credentialsId: "jenkins-notify-slack", variable: 'POST_URI')]) {
                                                    def postSlackData = "{ \"text\": \"${notifyPost}\" }"
                                                    try { sh "curl -s --data-urlencode 'payload=$postSlackData' 'https://hooks.slack.com/services/${POST_URI}'" }
                                                    catch(e) { echo "In catch block notifying slack - ${e}" }
                                                }
                                            } catch(e) { echo "Did not find slack credentials - would not notify" }
                                        }
                                    } catch(e) {
                                        echo "In catch scanning image - ${e}"
                                        throw e
                                    }
                                }
                            }
                        }
                    }
                }
            }
            post {
                always { echo "Done scanning ${params.dockerImage}" }
                changed { echo "changed?" }
                failure { echo "Build failed (${params.jobRetryCount} out of ${params.jobMaxRetry})" }
                success { echo "success!" }
                unstable { echo "unstable?" }
            }
        }
    type: JenkinsPipeline
